/*
 * Group.cpp
 *
 *  Created on: Aug 10, 2012
 *      Author: scottyoung
 */

#include "Group.h"

Group::Group(int numObjects) {

	maxN = numObjects;
	n = 0;
	members = new Object3D*[numObjects];

}

Group::~Group() {
	delete[] members;
}

bool Group::intersect(const Ray &r, Hit &h, float tMin)
{
	bool hit = false;
	for(int i=0; i<n; i++)
	{
		if(members[i]->intersect(r, h, tMin))
			hit = true;
	}
	return(hit);
}

void Group::addObject(Object3D *obj)
{
	if(n<maxN)
	{
		members[n] = obj;
		n++;
	}
}

void Group::print(){
	cout << "--Group [" << maxN << "]--" << endl;
	for(int i=0; i<n; i++)
	{
		cout << "\t" << i << ")";
		members[i]->print();
	}
}
