/*
 * Material.h
 *
 *  Created on: Sep 4, 2012
 *      Author: scottyoung
 */

#ifndef MATERIAL_H_
#define MATERIAL_H_
#include <iostream.h>
#include "vectors.h"

class Hit; class Ray;

class Material {
public:
	Material(Vec3f c){
			diffuseColor=c;
			Vec3f black(0,0,0);
			transparentColor = black;
			reflectiveColor = black;
			indexOfRefraction = 1.0;
	}
	Material(Vec3f d, Vec3f t, Vec3f r, float n)
	{
		diffuseColor = d;
		transparentColor = t;
		reflectiveColor = r;
		indexOfRefraction = n;
	}
	virtual ~Material(){

	}

	virtual Vec3f shade(const Ray &r, Hit *h, const Vec3f &dirToLight, const Vec3f &lightColor)=0;
	virtual void print()=0;
	Vec3f flatColor() { return diffuseColor; }
	Vec3f getReflectiveColor() { return reflectiveColor; }
	Vec3f getTransparentColor() { return transparentColor; }
	float reflectWeight() { return (reflectiveColor.r()+reflectiveColor.g()+reflectiveColor.b()) / 3.0; }
	float transparency() { return (transparentColor.r()+transparentColor.g()+transparentColor.b()) / 3.0; }
	float getIndex() { return indexOfRefraction; }

	Vec3f diffuseColor;
	Vec3f transparentColor;
	Vec3f reflectiveColor;
	float indexOfRefraction;

};

#endif /* MATERIAL_H_ */
