/*
 * Transform.cpp
 *
 *  Created on: Aug 14, 2012
 *      Author: scottyoung
 */

#include "Transform.h"

Transform::Transform(Matrix m, Object3D *o) {
	mat = m;
	obj = o;
}

Transform::~Transform() {
	// TODO Auto-generated destructor stub
}

bool Transform::intersect(const Ray &r, Hit &h, float tMin){

	bool hit = false;
	Vec3f D = r.getDirection();
	Vec3f O = r.getOrigin();
	Matrix invM(mat);
	invM.Inverse();

	invM.TransformDirection(D);
	invM.Transform(O);

	Ray R(D, O);
	hit = obj->intersect(R, h, tMin);
	if(hit)
	{
		Vec3f N = h.getNormal();
		Matrix invMT(invM);
		invMT.Transpose();

		invMT.TransformDirection(N);
		N.Normalize();
		h.set(h.getT(), h.getMaterial(), N, r);
	}

	return(hit);
}

void Transform::print(){
	cout << "Transform: " << endl;
	mat.Write();
	obj->print();
}
