/*
 * Group.cpp
 *
 *  Created on: Aug 10, 2012
 *      Author: scottyoung
 */

#include "Group.h"

Group::Group(int numObjects) {

	maxN = numObjects;
	n = 0;
	members = new Object3D*[numObjects];
	retrievalIndex = 0;
	isGroup=true;
	isTri=false;
}

Group::~Group() {
	delete[] members;
}

bool Group::intersect(const Ray &r, Hit &h, float tMin)
{
	bool hit = false;
	for(int i=0; i<n; i++)
	{
		if(members[i]->intersect(r, h, tMin))
			hit = true;
	}
	return(hit);
}

void Group::addObject(Object3D *obj)
{
	if(n<maxN)
	{
		members[n] = obj;
		n++;
	}
}

//Sets the bounds of the group by merging all member bounds together
void Group::setBounds()
{
	members[0]->setBounds();
	bounds = members[0]->getBoundingBox();
	for(int i=1; i<n; i++)
	{
		members[i]->setBounds();
		bounds = members[i]->getBoundingBox().mergeBox(bounds);
	}
}

void Group::print(){
	cout << "--Group [" << maxN << "]--" << endl;
	for(int i=0; i<n; i++)
	{
		cout << "\t" << i << ")";
		members[i]->print();
	}
}

Object3D* Group::firstObject(){
	retrievalIndex=0;
	return(members[0]);
}

Object3D* Group::nextObject(){
	retrievalIndex++;
	if(retrievalIndex < n)
		return(members[retrievalIndex]);
	else
		return(0);
}
