/*
 * PhongMaterial.cpp
 *
 *  Created on: Sep 4, 2012
 *      Author: scottyoung
 */

#include "PhongMaterial.h"


PhongMaterial::~PhongMaterial() {
	// TODO Auto-generated destructor stub
}

Vec3f PhongMaterial::shade(const Ray &r, Hit *h, const Vec3f &dirToLight, const Vec3f &lightColor){
	Vec3f N = h->getNormal();

	//Normal diffuse lighting of Lambertian surface
	float d = dirToLight.Dot3(N);
	Vec3f cDiff(lightColor.r()*diffuseColor.r()*d,
			lightColor.g()*diffuseColor.g()*d,
			lightColor.b()*diffuseColor.b()*d);

	//get the reflection vector = -I + 2(I*N)N
	Vec3f I(dirToLight);
	Vec3f R = Mirror(I, N);
	Vec3f E(r.getDirection());
	E.Normalize();
	E.Negate();

	//Calculate the magnitude
	d = R.Dot3(E);
	Vec3f value;
	if(d>0)
	{
		d = pow(d, exponent);
		//Specular component
		Vec3f cSpec(lightColor.r()*specularColor.r()*d,
			lightColor.g()*specularColor.g()*d,
			lightColor.b()*specularColor.b()*d);
		value = cSpec + cDiff;
	}
	else
	{
		value = cDiff;
	}

	return(value);
}

