/*
 * Checkerboard.h
 *
 *  Created on: Sep 26, 2012
 *      Author: scottyoung
 */

#ifndef CHECKERBOARD_H_
#define CHECKERBOARD_H_

#include "Material.h"
#include "ray.h"
#include "hit.h"

class Checkerboard: public Material {
public:
	Checkerboard(Material *m1, Material *m2, float cell_size);
	virtual ~Checkerboard();
	Vec3f shade(const Ray &r, Hit *h, const Vec3f &dirToLight, const Vec3f &lightColor);
	void glSetMaterial() const;
	void print();


private:
	Material *odd;
	Material *even;
	float cellSize;
};

#endif /* CHECKERBOARD_H_ */
