/*
 * PhongMaterial.h
 *
 *  Created on: Sep 4, 2012
 *      Author: scottyoung
 */

#ifndef PHONGMATERIAL_H_
#define PHONGMATERIAL_H_

#include "Material.h"
#include "ray.h"
#include "hit.h"

class PhongMaterial: public Material {
public:
	PhongMaterial(Vec3f d)
	:Material(d){
		specularColor = Vec3f(0,0,0);
		exponent = 1;
	}
	PhongMaterial(Vec3f d, Vec3f s, float x, Vec3f t, Vec3f r, float n)
	:Material(d,t,r,n){
		specularColor = s;
		exponent = x;
	}
	virtual ~PhongMaterial();
	Vec3f shade(const Ray &r, Hit *h, const Vec3f &dirToLight, const Vec3f &lightColor);
	void glSetMaterial() const;
	void print()
	{
		cout << "Phong Material: " << endl;
		cout << "~~~~~~" << endl;
		cout << "\tDiffuse: ";
		diffuseColor.Write();
		cout << "\tTransparent: ";
		transparentColor.Write();
		cout << "\tReflective: ";
		reflectiveColor.Write();
		cout << "\tIndex of refraction : " << indexOfRefraction << endl;
		cout << "\tSpecular: ";
		specularColor.Write();
		cout << "\tExponent: " << exponent << endl;
		cout << "~~~~~~" << endl;
	}

	Vec3f specularColor;
	float exponent;
};

#endif /* PHONGMATERIAL_H_ */
